use super::macros::intermediate;
use super::table_row::ITableRow;
use crate::error::CustomError;
use organic::types::StandardProperties;

#[derive(Debug, Clone)]
pub(crate) struct ITable {
    pub(crate) children: Vec<ITableRow>,
    pub(crate) post_blank: organic::types::PostBlank,
}

intermediate!(
    ITable,
    &'orig organic::types::Table<'parse>,
    original,
    intermediate_context,
    {
        let children = {
            let mut ret = Vec::new();
            for obj in original.children.iter() {
                ret.push(ITableRow::new(intermediate_context.clone(), obj).await?);
            }
            ret
        };

        Ok(ITable {
            children,
            post_blank: original.get_post_blank(),
        })
    }
);
